diff -Naur -x .svn stamp-0.9.10/bayes/bayes.c stamp-0.9.10_Distribute/bayes/bayes.c
--- stamp-0.9.10/bayes/bayes.c	2008-09-09 07:41:49.000000000 +0900
+++ stamp-0.9.10_Distribute/bayes/bayes.c	2014-12-18 12:17:57.985567633 +0900
@@ -67,10 +67,14 @@
  *
  * =============================================================================
  */
-
+/* Copyright (c) IBM Corp. 2014. */
 
 #include <assert.h>
+#if defined(__370__) || defined(_AIX)
+#include <unistd.h>  /* For getopt() */
+#else
 #include <getopt.h>
+#endif
 #include "data.h"
 #include "learner.h"
 #include "net.h"
@@ -78,6 +82,10 @@
 #include "timer.h"
 #include "tm.h"
 #include "types.h"
+#if defined(__bgq__)
+#include <stdint.h>
+#include <spi/include/kernel/location.h>
+#endif
 
 enum param_types {
     PARAM_EDGE    = (unsigned char)'e',
@@ -237,6 +245,46 @@
      */
 
     parseArgs(argc, (char** const)argv);
+#if defined(__bgq__)
+    if (global_params[PARAM_THREAD] < 0) {
+	uint32_t rank;
+	long maxThreads;
+
+	maxThreads = -global_params[PARAM_THREAD];
+	rank = Kernel_GetRank();
+	switch (rank) {
+	case 0:
+	    global_params[PARAM_THREAD] = 1;
+	    break;
+#if defined(GLOBAL_LOCK) || defined(HTM_IBM)
+	case 1:
+	    global_params[PARAM_THREAD] = 2;
+	    break;
+	case 2:
+	    global_params[PARAM_THREAD] = 4;
+	    break;
+	case 3:
+	    global_params[PARAM_THREAD] = 8;
+	    break;
+	case 4:
+	    global_params[PARAM_THREAD] = 16;
+	    break;
+	case 5:
+	    global_params[PARAM_THREAD] = 32;
+	    break;
+	case 6:
+	    global_params[PARAM_THREAD] = 64;
+	    break;
+#endif
+	default:
+	    exit(0);
+	    break;
+	}
+	if (maxThreads < global_params[PARAM_THREAD]) {
+	    exit(0);
+	}
+    }
+#endif
     long numThread     = global_params[PARAM_THREAD];
     long numVar        = global_params[PARAM_VAR];
     long numRecord     = global_params[PARAM_RECORD];
diff -Naur -x .svn stamp-0.9.10/bayes/Defines.common.mk stamp-0.9.10_Distribute/bayes/Defines.common.mk
--- stamp-0.9.10/bayes/Defines.common.mk	2008-09-09 07:41:49.000000000 +0900
+++ stamp-0.9.10_Distribute/bayes/Defines.common.mk	2014-12-18 12:35:51.523567385 +0900
@@ -3,7 +3,9 @@
 # Defines.common.mk
 #
 # ==============================================================================
+# Copyright (c) IBM Corp. 2014, and others.
 
+hostname := $(shell hostname)
 
 PROG := bayes
 
@@ -21,6 +23,7 @@
 	$(LIB)/random.c \
 	$(LIB)/thread.c \
 	$(LIB)/vector.c \
+	$(LIB)/memory.c
 #
 OBJS := ${SRCS:.c=.o}
 
@@ -28,6 +31,48 @@
 CFLAGS += -DLEARNER_TRY_REMOVE
 CFLAGS += -DLEARNER_TRY_REVERSE
 
+RUNPARAMS := -v32 -r4096 -n10 -p40 -i2 -e8 -s1
+
+.PHONY:	run1 run2 run4 run6 run8 run12 run16 run32 run64 run128 run-16 run-32 run-64
+
+run1:
+	$(PROGRAM) $(RUNPARAMS) -t1
+
+run2:
+	$(PROGRAM) $(RUNPARAMS) -t2
+
+run4:
+	$(PROGRAM) $(RUNPARAMS) -t4
+
+run6:
+	$(PROGRAM) $(RUNPARAMS) -t6
+
+run8:
+	$(PROGRAM) $(RUNPARAMS) -t8
+
+run12:
+	$(PROGRAM) $(RUNPARAMS) -t12
+
+run16:
+	$(PROGRAM) $(RUNPARAMS) -t16
+
+run32:
+	$(PROGRAM) $(RUNPARAMS) -t32
+
+run64:
+	$(PROGRAM) $(RUNPARAMS) -t64
+
+run128:
+	$(PROGRAM) $(RUNPARAMS) -t128
+
+run-16:
+	$(PROGRAM) $(RUNPARAMS) -t-16
+
+run-32:
+	$(PROGRAM) $(RUNPARAMS) -t-32
+
+run-64:
+	$(PROGRAM) $(RUNPARAMS) -t-64
 
 # ==============================================================================
 #
diff -Naur -x .svn stamp-0.9.10/bayes/learner.c stamp-0.9.10_Distribute/bayes/learner.c
--- stamp-0.9.10/bayes/learner.c	2008-09-09 07:41:49.000000000 +0900
+++ stamp-0.9.10_Distribute/bayes/learner.c	2014-12-18 12:18:09.128880187 +0900
@@ -114,6 +114,7 @@
  *
  * =============================================================================
  */
+/* Copyright (c) IBM Corp. 2014. */
 
 
 #include <assert.h>
@@ -300,13 +301,22 @@
                  long* startPtr, long* stopPtr)
 {
     long range = max - min;
+#ifdef __GNUC__
     long chunk = MAX(1, ((range + n/2) / n)); /* rounded */
+#else
+    long _tmp = (range + n/2) / n;
+    long chunk = MAX_nogcc(1, _tmp); /* rounded */
+#endif
     long start = min + chunk * id;
     long stop;
     if (id == (n-1)) {
         stop = max;
     } else {
+#ifdef __GNUC__
         stop = MIN(max, (start + chunk));
+#else
+        stop = MIN_nogcc(max, (start + chunk));
+#endif
     }
 
     *startPtr = start;
@@ -383,7 +393,7 @@
 
     } /* foreach variable */
 
-    TM_BEGIN();
+    TM_BEGIN_ID(0);
     float globalBaseLogLikelihood =
         TM_SHARED_READ_F(learnerPtr->baseLogLikelihood);
     TM_SHARED_WRITE_F(learnerPtr->baseLogLikelihood,
@@ -478,7 +488,7 @@
             taskPtr->fromId = bestLocalIndex;
             taskPtr->toId = v;
             taskPtr->score = score;
-            TM_BEGIN();
+            TM_BEGIN_ID(1);
             status = TMLIST_INSERT(taskListPtr, (void*)taskPtr);
             TM_END();
             assert(status);
@@ -1186,7 +1196,7 @@
     while (1) {
 
         learner_task_t* taskPtr;
-        TM_BEGIN();
+        TM_BEGIN_ID(2);
         taskPtr = TMpopTask(TM_ARG  taskListPtr);
         TM_END();
         if (taskPtr == NULL) {
@@ -1199,7 +1209,7 @@
 
         bool_t isTaskValid;
 
-        TM_BEGIN();
+        TM_BEGIN_ID(3);
 
         /*
          * Check if task is still valid
@@ -1264,7 +1274,7 @@
             switch (op) {
                 float newBaseLogLikelihood;
                 case OPERATION_INSERT: {
-                    TM_BEGIN();
+                    TM_BEGIN_ID(4);
                     TMpopulateQueryVectors(TM_ARG
                                            netPtr,
                                            toId,
@@ -1285,7 +1295,7 @@
                     TM_SHARED_WRITE_F(localBaseLogLikelihoods[toId],
                                       newBaseLogLikelihood);
                     TM_END();
-                    TM_BEGIN();
+                    TM_BEGIN_ID(5);
                     long numTotalParent = (long)TM_SHARED_READ(learnerPtr->numTotalParent);
                     TM_SHARED_WRITE(learnerPtr->numTotalParent, (numTotalParent + 1));
                     TM_END();
@@ -1293,7 +1303,7 @@
                 }
 #ifdef LEARNER_TRY_REMOVE
                 case OPERATION_REMOVE: {
-                    TM_BEGIN();
+                    TM_BEGIN_ID(6);
                     TMpopulateQueryVectors(TM_ARG
                                            netPtr,
                                            fromId,
@@ -1314,7 +1324,7 @@
                     TM_SHARED_WRITE_F(localBaseLogLikelihoods[fromId],
                                       newBaseLogLikelihood);
                     TM_END();
-                    TM_BEGIN();
+                    TM_BEGIN_ID(7);
                     long numTotalParent = (long)TM_SHARED_READ(learnerPtr->numTotalParent);
                     TM_SHARED_WRITE(learnerPtr->numTotalParent, (numTotalParent - 1));
                     TM_END();
@@ -1323,7 +1333,7 @@
 #endif /* LEARNER_TRY_REMOVE */
 #ifdef LEARNER_TRY_REVERSE
                 case OPERATION_REVERSE: {
-                    TM_BEGIN();
+                    TM_BEGIN_ID(8);
                     TMpopulateQueryVectors(TM_ARG
                                            netPtr,
                                            fromId,
@@ -1345,7 +1355,7 @@
                                       newBaseLogLikelihood);
                     TM_END();
 
-                    TM_BEGIN();
+                    TM_BEGIN_ID(9);
                     TMpopulateQueryVectors(TM_ARG
                                            netPtr,
                                            toId,
@@ -1382,7 +1392,7 @@
         float baseLogLikelihood;
         long numTotalParent;
 
-        TM_BEGIN();
+        TM_BEGIN_ID(10);
         float oldBaseLogLikelihood =
             (float)TM_SHARED_READ_F(learnerPtr->baseLogLikelihood);
         float newBaseLogLikelihood = oldBaseLogLikelihood + deltaLogLikelihood;
@@ -1411,7 +1421,7 @@
         arg.basePenalty       = basePenalty;
         arg.baseLogLikelihood = baseLogLikelihood;
 
-        TM_BEGIN();
+        TM_BEGIN_ID(11);
         newTask = TMfindBestInsertTask(TM_ARG  &arg);
         TM_END();
 
@@ -1422,7 +1432,7 @@
         }
 
 #ifdef LEARNER_TRY_REMOVE
-        TM_BEGIN();
+        TM_BEGIN_ID(12);
         newTask = TMfindBestRemoveTask(TM_ARG  &arg);
         TM_END();
 
@@ -1434,7 +1444,7 @@
 #endif /* LEARNER_TRY_REMOVE */
 
 #ifdef LEARNER_TRY_REVERSE
-        TM_BEGIN();
+        TM_BEGIN_ID(13);
         newTask = TMfindBestReverseTask(TM_ARG  &arg);
         TM_END();
 
@@ -1448,7 +1458,7 @@
         if (bestTask.toId != -1) {
             learner_task_t* tasks = learnerPtr->tasks;
             tasks[toId] = bestTask;
-            TM_BEGIN();
+            TM_BEGIN_ID(14);
             TMLIST_INSERT(taskListPtr, (void*)&tasks[toId]);
             TM_END();
 #ifdef TEST_LEARNER
diff -Naur -x .svn stamp-0.9.10/bayes/learner.h stamp-0.9.10_Distribute/bayes/learner.h
--- stamp-0.9.10/bayes/learner.h	2008-09-09 07:41:49.000000000 +0900
+++ stamp-0.9.10_Distribute/bayes/learner.h	2014-12-18 12:18:18.303758325 +0900
@@ -68,6 +68,7 @@
  *
  * =============================================================================
  */
+/* Copyright (c) IBM Corp. 2014. */
 
 
 #ifndef LEARNER_H
@@ -80,7 +81,17 @@
 
 typedef struct learner_task learner_task_t;
 
+#if defined( __370__)
+#define CACHE_LINE_SIZE (256)
+#elif defined(__bgq__)
+#define CACHE_LINE_SIZE (128)
+#elif defined(__PPC__) || defined(_ARCH_PPC)
+#define CACHE_LINE_SIZE (128)
+#elif defined(__x86_64__)
 #define CACHE_LINE_SIZE (64)
+#else
+#define CACHE_LINE_SIZE (64)
+#endif
 
 typedef struct learner {
     adtree_t* adtreePtr;
diff -Naur -x .svn stamp-0.9.10/bayes/Makefile.hle_intel stamp-0.9.10_Distribute/bayes/Makefile.hle_intel
--- stamp-0.9.10/bayes/Makefile.hle_intel	1970-01-01 09:00:00.000000000 +0900
+++ stamp-0.9.10_Distribute/bayes/Makefile.hle_intel	2014-12-18 12:25:58.863661327 +0900
@@ -0,0 +1,17 @@
+# ==============================================================================
+#
+# Makefile.hle_intel
+#
+# ==============================================================================
+# Copyright (c) IBM Corp. 2014, and others.
+
+
+include ../common/Defines.common.mk
+include ./Defines.common.mk
+include ../common/Makefile.hle_intel
+
+# ==============================================================================
+#
+# End of Makefile.hle_intel
+#
+# ==============================================================================
diff -Naur -x .svn stamp-0.9.10/bayes/Makefile.htm_ibm stamp-0.9.10_Distribute/bayes/Makefile.htm_ibm
--- stamp-0.9.10/bayes/Makefile.htm_ibm	1970-01-01 09:00:00.000000000 +0900
+++ stamp-0.9.10_Distribute/bayes/Makefile.htm_ibm	2014-12-18 12:26:05.517598840 +0900
@@ -0,0 +1,17 @@
+# ==============================================================================
+#
+# Makefile.htm_ibm
+#
+# ==============================================================================
+# Copyright (c) IBM Corp. 2014, and others.
+
+
+include ../common/Defines.common.mk
+include ./Defines.common.mk
+include ../common/Makefile.htm_ibm
+
+# ==============================================================================
+#
+# End of Makefile.htm_ibm
+#
+# ==============================================================================
diff -Naur -x .svn stamp-0.9.10/common/Defines.common.mk stamp-0.9.10_Distribute/common/Defines.common.mk
--- stamp-0.9.10/common/Defines.common.mk	2008-09-09 07:42:37.000000000 +0900
+++ stamp-0.9.10_Distribute/common/Defines.common.mk	2014-12-18 15:33:30.689601157 +0900
@@ -3,16 +3,56 @@
 # Defines.common.mk
 #
 # ==============================================================================
+# Copyright (c) IBM Corp. 2014, and others.
 
+enable_IBM_optimizations := yes
 
+platform := $(shell uname)
+architecture := $(shell uname -m)
+hostname := $(shell hostname)
+ifeq ($(platform),OS/390)
+CC       := c89
+CFLAGS   += '-Wc,HALTON(3296),LANGLVL(extc99),FLOAT(ieee),XPLINK,ARCH(10),TUNE(10),LP64'
+CFLAGS   += -D_XOPEN_SOURCE=600 -D_UNIX03_SOURCE
+CFLAGS   += -O3
+CFLAGS   += -I$(LIB)
+CPP      := c++
+CPPFLAGS += $(CFLAGS)
+LD       := c89
+LDFLAGS  += -Wl,XPLINK,LP64
+LIBS     += 
+else
+ifeq ($(platform),AIX)
+CC       := /usr/vac/bin/xlc_r
+CFLAGS   += -O3 -q64 -g -qstrict
+CFLAGS   += -I$(LIB)
+CPP      := /usr/vac/bin/xlC_r
+CPPFLAGS += $(CFLAGS)
+LD       := /usr/vac/bin/xlc_r
+LDFLAGS  += $(CFLAGS)
+LIBS     += -lm
+else
 CC       := gcc
+ifeq ($(architecture),x86_64)
+CFLAGS   += -g -Wall -pthread  # We no longer use gcc's built-in functions for TSX.
+#CFLAGS   += -g -Wall -pthread -mrtm  # For hle_intel, enable this.
+else
+ifeq ($(architecture),ppc64)
+# We need 64-bit binaries, because bayes allocates > 3GB memory.
+CFLAGS   += -g -Wall -pthread -mpowerpc64 -mcpu=power6 -m64
+else
 CFLAGS   += -g -Wall -pthread
+endif
+endif
 CFLAGS   += -O3
 CFLAGS   += -I$(LIB)
 CPP      := g++
 CPPFLAGS += $(CFLAGS)
 LD       := g++
 LIBS     += -lpthread
+LDFLAGS  += $(CFLAGS)
+endif
+endif
 
 # Remove these files when doing clean
 OUTPUT +=
diff -Naur -x .svn stamp-0.9.10/common/Makefile.hle_intel stamp-0.9.10_Distribute/common/Makefile.hle_intel
--- stamp-0.9.10/common/Makefile.hle_intel	1970-01-01 09:00:00.000000000 +0900
+++ stamp-0.9.10_Distribute/common/Makefile.hle_intel	2014-12-18 12:36:31.294599240 +0900
@@ -0,0 +1,43 @@
+# ==============================================================================
+#
+# Makefile.hle_intel
+#
+# ==============================================================================
+# Copyright (c) IBM Corp. 2014, and others.
+
+CFLAGS += -DHLE_INTEL
+# CFLAGS += -mrtm		# x86_64 GCC
+# CFLAGS += -mhtm		# PPC GCC
+#LDFLAGS += -static
+
+SRCS += $(LIB)/hle_intel.c
+
+OBJS := ${SRCS:.c=.o}
+
+# ==============================================================================
+# Rules
+# ==============================================================================
+
+.PHONY: default
+default: $(PROG).hle_intel
+
+.PHONY: clean cleanobj
+clean:
+	$(RM) $(OBJS) $(PROG).hle_intel $(OUTPUT)
+
+cleanobj:
+	$(RM) $(OBJS) $(OUTPUT)
+
+$(PROG).hle_intel: $(OBJS)
+	$(LD) $(LDFLAGS) $^ $(LIBS) -o $(PROG).hle_intel
+
+include ../common/Makefile.common
+
+PROGRAM := ./$(PROG).hle_intel
+
+# ==============================================================================
+#
+# Makefile.seq
+#
+# ==============================================================================
+
diff -Naur -x .svn stamp-0.9.10/common/Makefile.htm_ibm stamp-0.9.10_Distribute/common/Makefile.htm_ibm
--- stamp-0.9.10/common/Makefile.htm_ibm	1970-01-01 09:00:00.000000000 +0900
+++ stamp-0.9.10_Distribute/common/Makefile.htm_ibm	2014-12-18 12:36:37.110661621 +0900
@@ -0,0 +1,46 @@
+# ==============================================================================
+#
+# Makefile.htm_ibm
+#
+# ==============================================================================
+# Copyright (c) IBM Corp. 2014, and others.
+
+hostname := $(shell hostname)
+
+CFLAGS += -DHTM_IBM # -DUSE_MUTEX
+# CFLAGS += -mrtm		# x86_64 GCC
+# CFLAGS += -mhtm		# PPC GCC
+#LDFLAGS += -static
+
+SRCS += $(LIB)/htm_ibm.c \
+     $(LIB)/htm_util.c
+
+OBJS := ${SRCS:.c=.o}
+
+# ==============================================================================
+# Rules
+# ==============================================================================
+
+.PHONY: default
+default: $(PROG).htm_ibm
+
+.PHONY: clean cleanobj
+clean:
+	$(RM) $(OBJS) $(PROG).htm_ibm $(OUTPUT)
+
+cleanobj:
+	$(RM) $(OBJS) $(OUTPUT)
+
+$(PROG).htm_ibm: $(OBJS)
+	$(LD) $(LDFLAGS) $^ $(LIBS) -o $(PROG).htm_ibm
+
+include ../common/Makefile.common
+
+PROGRAM := ./$(PROG).htm_ibm
+
+# ==============================================================================
+#
+# Makefile.seq
+#
+# ==============================================================================
+
diff -Naur -x .svn stamp-0.9.10/common/Makefile.seq stamp-0.9.10_Distribute/common/Makefile.seq
--- stamp-0.9.10/common/Makefile.seq	2008-09-09 07:42:37.000000000 +0900
+++ stamp-0.9.10_Distribute/common/Makefile.seq	2014-12-18 12:36:48.697598732 +0900
@@ -3,24 +3,30 @@
 # Makefile.seq
 #
 # ==============================================================================
+# Copyright (c) IBM Corp. 2014, and others.
 
+#CFLAGS += -DGLOBAL_LOCK
 
 # ==============================================================================
 # Rules
 # ==============================================================================
 
 .PHONY: default
-default: $(PROG)
+default: $(PROG).seq
 
-.PHONY: clean
+.PHONY: clean cleanobj
 clean:
-	$(RM) $(OBJS) $(PROG) $(OUTPUT)
+	$(RM) $(OBJS) $(PROG).seq $(OUTPUT)
 
-$(PROG): $(OBJS)
-	$(LD) $(LDFLAGS) $^ $(LIBS) -o $(PROG)
+cleanobj:
+	$(RM) $(OBJS) $(OUTPUT)
+
+$(PROG).seq: $(OBJS)
+	$(LD) $(LDFLAGS) $^ $(LIBS) -o $(PROG).seq
 
 include ../common/Makefile.common
 
+PROGRAM := ./$(PROG).seq
 
 # ==============================================================================
 #
diff -Naur -x .svn stamp-0.9.10/genome/Defines.common.mk stamp-0.9.10_Distribute/genome/Defines.common.mk
--- stamp-0.9.10/genome/Defines.common.mk	2008-09-09 07:41:50.000000000 +0900
+++ stamp-0.9.10_Distribute/genome/Defines.common.mk	2014-12-18 15:38:13.954790275 +0900
@@ -3,10 +3,29 @@
 # Defines.common.mk
 #
 # ==============================================================================
+# Copyright (c) IBM Corp. 2014, and others.
 
 
+platform := $(shell uname)
+architecture := $(shell uname -m)
+hostname := $(shell hostname)
+
+CFLAGS += -DUSE_TLH
 CFLAGS += -DLIST_NO_DUPLICATES
-CFLAGS += -DCHUNK_STEP1=12
+
+ifeq ($(enable_IBM_optimizations),yes)
+ifeq ($(platform),AIX)
+CFLAGS += -DCHUNK_STEP1=2  # For P8
+else
+ifeq ($(architecture),ppc64)
+CFLAGS += -DCHUNK_STEP1=2  # For P8
+else
+CFLAGS += -DCHUNK_STEP1=2  # Optimized default
+endif
+endif
+else
+CFLAGS += -DCHUNK_STEP1=12  # Default for original STAMP
+endif
 
 PROG := genome
 
@@ -25,9 +44,53 @@
 	$(LIB)/mt19937ar.c \
 	$(LIB)/thread.c \
 	$(LIB)/vector.c \
+	$(LIB)/memory.c
 #
 OBJS := ${SRCS:.c=.o}
 
+#RUNPARAMS := -g256 -s16 -n16384
+RUNPARAMS := -g16384 -s64 -n16777216
+
+.PHONY:	run1 run2 run4 run6 run8 run12 run16 run32 run64 run128 run-16 run-32 run-64
+
+run1:
+	$(PROGRAM) $(RUNPARAMS) -t1
+
+run2:
+	$(PROGRAM) $(RUNPARAMS) -t2
+
+run4:
+	$(PROGRAM) $(RUNPARAMS) -t4
+
+run6:
+	$(PROGRAM) $(RUNPARAMS) -t6
+
+run8:
+	$(PROGRAM) $(RUNPARAMS) -t8
+
+run12:
+	$(PROGRAM) $(RUNPARAMS) -t12
+
+run16:
+	$(PROGRAM) $(RUNPARAMS) -t16
+
+run32:
+	$(PROGRAM) $(RUNPARAMS) -t32
+
+run64:
+	$(PROGRAM) $(RUNPARAMS) -t64
+
+run128:
+	$(PROGRAM) $(RUNPARAMS) -t128
+
+run-16:
+	$(PROGRAM) $(RUNPARAMS) -t-16
+
+run-32:
+	$(PROGRAM) $(RUNPARAMS) -t-32
+
+run-64:
+	$(PROGRAM) $(RUNPARAMS) -t-64
 
 # ==============================================================================
 #
diff -Naur -x .svn stamp-0.9.10/genome/genome.c stamp-0.9.10_Distribute/genome/genome.c
--- stamp-0.9.10/genome/genome.c	2008-09-09 07:41:50.000000000 +0900
+++ stamp-0.9.10_Distribute/genome/genome.c	2014-12-18 12:18:37.117595423 +0900
@@ -67,10 +67,15 @@
  *
  * =============================================================================
  */
+/* Copyright (c) IBM Corp. 2014. */
 
 
 #include <assert.h>
+#if defined(__370__) || defined(_AIX)
+#include <unistd.h>  /* For getopt() */
+#else
 #include <getopt.h>
+#endif
 #include <stdio.h>
 #include <stdlib.h>
 #include <string.h>
@@ -82,6 +87,10 @@
 #include "timer.h"
 #include "tm.h"
 #include "vector.h"
+#if defined(__bgq__)
+#include <stdint.h>
+#include <spi/include/kernel/location.h>
+#endif
 
 
 enum param_types {
@@ -188,6 +197,46 @@
 
     /* Initialization */
     parseArgs(argc, (char** const)argv);
+#if defined(__bgq__)
+    if (global_params[PARAM_THREAD] < 0) {
+	uint32_t rank;
+	long maxThreads;
+
+	maxThreads = -global_params[PARAM_THREAD];
+	rank = Kernel_GetRank();
+	switch (rank) {
+	case 0:
+	    global_params[PARAM_THREAD] = 1;
+	    break;
+#if defined(GLOBAL_LOCK) || defined(HTM_IBM)
+	case 1:
+	    global_params[PARAM_THREAD] = 2;
+	    break;
+	case 2:
+	    global_params[PARAM_THREAD] = 4;
+	    break;
+	case 3:
+	    global_params[PARAM_THREAD] = 8;
+	    break;
+	case 4:
+	    global_params[PARAM_THREAD] = 16;
+	    break;
+	case 5:
+	    global_params[PARAM_THREAD] = 32;
+	    break;
+	case 6:
+	    global_params[PARAM_THREAD] = 64;
+	    break;
+#endif
+	default:
+	    exit(0);
+	    break;
+	}
+	if (maxThreads < global_params[PARAM_THREAD]) {
+	    exit(0);
+	}
+    }
+#endif
     SIM_GET_NUM_CPU(global_params[PARAM_THREAD]);
 
     printf("Creating gene and segments... ");
diff -Naur -x .svn stamp-0.9.10/genome/Makefile.hle_intel stamp-0.9.10_Distribute/genome/Makefile.hle_intel
--- stamp-0.9.10/genome/Makefile.hle_intel	1970-01-01 09:00:00.000000000 +0900
+++ stamp-0.9.10_Distribute/genome/Makefile.hle_intel	2014-12-18 12:37:08.658630038 +0900
@@ -0,0 +1,18 @@
+# ==============================================================================
+#
+# Makefile.hle_intel
+#
+# ==============================================================================
+# Copyright (c) IBM Corp. 2014, and others.
+
+
+include ../common/Defines.common.mk
+include ./Defines.common.mk
+include ../common/Makefile.hle_intel
+
+# ==============================================================================
+#
+# Makefile.hle_intel
+#
+# ==============================================================================
+
diff -Naur -x .svn stamp-0.9.10/genome/Makefile.htm_ibm stamp-0.9.10_Distribute/genome/Makefile.htm_ibm
--- stamp-0.9.10/genome/Makefile.htm_ibm	1970-01-01 09:00:00.000000000 +0900
+++ stamp-0.9.10_Distribute/genome/Makefile.htm_ibm	2014-12-18 12:37:16.428945330 +0900
@@ -0,0 +1,18 @@
+# ==============================================================================
+#
+# Makefile.htm_ibm
+#
+# ==============================================================================
+# Copyright (c) IBM Corp. 2014, and others.
+
+
+include ../common/Defines.common.mk
+include ./Defines.common.mk
+include ../common/Makefile.htm_ibm
+
+# ==============================================================================
+#
+# Makefile.htm_ibm
+#
+# ==============================================================================
+
diff -Naur -x .svn stamp-0.9.10/genome/nucleotide.h stamp-0.9.10_Distribute/genome/nucleotide.h
--- stamp-0.9.10/genome/nucleotide.h	2008-09-09 07:41:50.000000000 +0900
+++ stamp-0.9.10_Distribute/genome/nucleotide.h	2014-12-18 12:18:47.093630686 +0900
@@ -67,6 +67,7 @@
  *
  * =============================================================================
  */
+/* Copyright (c) IBM Corp. 2014. */
 
 
 #ifndef NUCLEOTIDE_H
@@ -74,10 +75,18 @@
 
 
 typedef enum nucleotide_type {
+#ifdef __370__
+    /* Use ASCII for compatibility */
+    NUCLEOTIDE_ADENINE  = '\x61',
+    NUCLEOTIDE_CYTOSINE = '\x63',
+    NUCLEOTIDE_GUANINE  = '\x67',
+    NUCLEOTIDE_THYMINE  = '\x74',
+#else
     NUCLEOTIDE_ADENINE  = 'a',
     NUCLEOTIDE_CYTOSINE = 'c',
     NUCLEOTIDE_GUANINE  = 'g',
     NUCLEOTIDE_THYMINE  = 't',
+#endif
     NUCLEOTIDE_NUM_TYPE = 4
 } nucleotide_type_t;
 
diff -Naur -x .svn stamp-0.9.10/genome/segments.c stamp-0.9.10_Distribute/genome/segments.c
--- stamp-0.9.10/genome/segments.c	2008-09-09 07:41:51.000000000 +0900
+++ stamp-0.9.10_Distribute/genome/segments.c	2014-12-18 12:19:06.248630798 +0900
@@ -68,6 +68,7 @@
  *
  * =============================================================================
  */
+/* Copyright (c) IBM Corp. 2014. */
 
 
 #include <assert.h>
@@ -184,7 +185,11 @@
     /* Add extra segments to fill holes and ensure overlap */
     maxZeroRunLength = segmentLength - 1;
     for (i = 0; i < numStart; i++) {
+#ifdef __GNUC__
         long i_stop = MIN((i+maxZeroRunLength), numStart);
+#else
+        long i_stop = MIN_nogcc((i+maxZeroRunLength), numStart);
+#endif
         for ( /* continue */; i < i_stop; i++) {
             if (bitmap_isSet(startBitmapPtr, i)) {
                 break;
diff -Naur -x .svn stamp-0.9.10/genome/segments.h stamp-0.9.10_Distribute/genome/segments.h
--- stamp-0.9.10/genome/segments.h	2008-09-09 07:41:51.000000000 +0900
+++ stamp-0.9.10_Distribute/genome/segments.h	2014-12-18 12:19:10.490661083 +0900
@@ -68,6 +68,7 @@
  *
  * =============================================================================
  */
+/* Copyright (c) IBM Corp. 2014. */
 
 
 #ifndef SEGMENTS_H
diff -Naur -x .svn stamp-0.9.10/genome/sequencer.c stamp-0.9.10_Distribute/genome/sequencer.c
--- stamp-0.9.10/genome/sequencer.c	2008-09-09 07:41:51.000000000 +0900
+++ stamp-0.9.10_Distribute/genome/sequencer.c	2014-12-17 16:11:03.488692872 +0900
@@ -139,7 +139,19 @@
 static ulong_t
 hashSegment (const void* keyPtr)
 {
+#if 0
+  char *str = (char *)keyPtr;
+  ulong_t hash = 0;
+    ulong_t c;
+
+    while ((c = *str++) != '\0') {
+        hash = c + (hash << 6) + (hash << 16) - hash;
+    }
+
+    return hash;
+#else
     return (ulong_t)hash_sdbm((char*)keyPtr); /* can be any "good" hash function */
+#endif
 }
 
 
@@ -151,7 +163,27 @@
 static long
 compareSegment (const pair_t* a, const pair_t* b)
 {
+#if 0
+  char *a_str = (char *)(a->firstPtr);
+  char *b_str = (char *)(b->firstPtr);
+  for ( ; ; ) {
+    char a_char = *a_str++;
+    char b_char = *b_str++;
+    char diff;
+    if (a_char == '\0') {
+      if (b_char == '\0')
+	return 0;
+      return -1;
+    } else if (b_char == '\0') {
+      return 1;
+    }
+    diff = a_char - b_char;
+    if (diff != 0)
+      return (long)(signed char)diff;
+  }
+#else
     return strcmp((char*)(a->firstPtr), (char*)(b->firstPtr));
+#endif
 }
 
 
@@ -270,7 +302,7 @@
     /*
      * Step 1: Remove duplicate segments
      */
-#if defined(HTM) || defined(STM)
+#if defined(HTM) || defined(STM) || defined(HTM_IBM) || defined(HLE_INTEL) || defined(GLOBAL_LOCK)
     long numThread = thread_getNumThread();
     {
         /* Choose disjoint segments [i_start,i_stop) for each thread */
@@ -287,10 +319,14 @@
     i_stop = numSegment;
 #endif /* !(HTM || STM) */
     for (i = i_start; i < i_stop; i+=CHUNK_STEP1) {
-        TM_BEGIN();
+        TM_BEGIN_ID(0);
         {
             long ii;
+#ifdef __GNUC__
             long ii_stop = MIN(i_stop, (i+CHUNK_STEP1));
+#else
+            long ii_stop = MIN_nogcc(i_stop, (i+CHUNK_STEP1));
+#endif
             for (ii = i; ii < ii_stop; ii++) {
                 void* segment = vector_at(segmentsContentsPtr, ii);
                 TMHASHTABLE_INSERT(uniqueSegmentsPtr,
@@ -327,7 +363,7 @@
     numUniqueSegment = hashtable_getSize(uniqueSegmentsPtr);
     entryIndex = 0;
 
-#if defined(HTM) || defined(STM)
+#if defined(HTM) || defined(STM) || defined(HTM_IBM) || defined(HLE_INTEL) || defined(GLOBAL_LOCK)
     {
         /* Choose disjoint segments [i_start,i_stop) for each thread */
         long num = uniqueSegmentsPtr->numBucket;
@@ -366,7 +402,7 @@
             bool_t status;
 
             /* Find an empty constructEntries entry */
-            TM_BEGIN();
+            TM_BEGIN_ID(1);
             while (((void*)TM_SHARED_READ_P(constructEntries[entryIndex].segment)) != NULL) {
                 entryIndex = (entryIndex + 1) % numUniqueSegment; /* look for empty */
             }
@@ -392,7 +428,7 @@
             for (j = 1; j < segmentLength; j++) {
                 startHash = (ulong_t)segment[j-1] +
                             (startHash << 6) + (startHash << 16) - startHash;
-                TM_BEGIN();
+                TM_BEGIN_ID(2);
                 status = TMTABLE_INSERT(startHashToConstructEntryTables[j],
                                         (ulong_t)startHash,
                                         (void*)constructEntryPtr );
@@ -405,7 +441,7 @@
              */
             startHash = (ulong_t)segment[j-1] +
                         (startHash << 6) + (startHash << 16) - startHash;
-            TM_BEGIN();
+            TM_BEGIN_ID(3);
             status = TMTABLE_INSERT(hashToConstructEntryTable,
                                     (ulong_t)startHash,
                                     (void*)constructEntryPtr);
@@ -429,7 +465,7 @@
         long index_start;
         long index_stop;
 
-#if defined(HTM) || defined(STM)
+#if defined(HTM) || defined(STM) || defined(HTM_IBM) || defined(HLE_INTEL) || defined(GLOBAL_LOCK)
         {
             /* Choose disjoint segments [index_start,index_stop) for each thread */
             long partitionSize = (numUniqueSegment + numThread/2) / numThread; /* with rounding */
@@ -473,7 +509,7 @@
                 long newLength = 0;
 
                 /* endConstructEntryPtr is local except for properties startPtr/endPtr/length */
-                TM_BEGIN();
+                TM_BEGIN_ID(4);
 
                 /* Check if matches */
                 if (TM_SHARED_READ(startConstructEntryPtr->isStart) &&
@@ -551,7 +587,11 @@
                         constructEntry_t* constructEntryPtr = &constructEntries[i];
                         char* segment = constructEntryPtr->segment;
                         constructEntryPtr->endHash = (ulong_t)hashString(&segment[index]);
+#ifdef __GNUC__
                         endInfoEntries[j].jumpToNext = MAX(1, (i - j));
+#else
+                        endInfoEntries[j].jumpToNext = MAX_nogcc(1, (i - j));
+#endif
                         j = i;
                     }
                 }
